angular-rails-templates uses MD5 causing problems FIPS-enabled envrionments

04/18/2018 02:41 PM - Peter Ondrejka

Status: Closed   

Priority: Normal   

Assignee:    

Category: RPMs   

Target version:    

Difficulty:  Fixed in Releases: 1.20.0

Triaged: Yes Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman-p

ackaging/pull/3046

  

Description

The angular-rails-templates gem is probably not FIPS compatible. This came out after enabling FIPS mode on the underlying rhel 7

(using a workaround that overrides Digest::MD5 class and logs which gem used it), after restarting services I'm seeing:

2018-04-18T08:57:36 [W|app|] FIPS issue: calling 'hexdigest' from

 | /opt/theforeman/tfm/root/usr/share/gems/gems/angular-rails-templates-1.0.2/lib/angular-rails-te

mplates/engine.rb:43:in `block in <class:Engine>'

 | /opt/theforeman/tfm-ror51/root/usr/share/gems/gems/railties-5.1.4/lib/rails/initializable.rb:30

:in `instance_exec'

 | /opt/theforeman/tfm-ror51/root/usr/share/gems/gems/railties-5.1.4/lib/rails/initializable.rb:30

:in `run'

 | /opt/theforeman/tfm-ror51/root/usr/share/gems/gems/railties-5.1.4/lib/rails/initializable.rb:59

:in `block in run_initializers'

 | /opt/rh/rh-ruby24/root/usr/share/ruby/tsort.rb:228:in `block in tsort_each'

 | /opt/rh/rh-ruby24/root/usr/share/ruby/tsort.rb:350:in `block (2 levels) in each_strongly_connec

ted_component'

 | /opt/rh/rh-ruby24/root/usr/share/ruby/tsort.rb:431:in `each_strongly_connected_component_from'

 | /opt/rh/rh-ruby24/root/usr/share/ruby/tsort.rb:349:in `block in each_strongly_connected_compone

nt'

 | /opt/rh/rh-ruby24/root/usr/share/ruby/tsort.rb:347:in `each'

 | /opt/rh/rh-ruby24/root/usr/share/ruby/tsort.rb:347:in `call'

 | /opt/rh/rh-ruby24/root/usr/share/ruby/tsort.rb:347:in `each_strongly_connected_component'

 | /opt/rh/rh-ruby24/root/usr/share/ruby/tsort.rb:226:in `tsort_each'

 | /opt/rh/rh-ruby24/root/usr/share/ruby/tsort.rb:205:in `tsort_each'

 | /opt/theforeman/tfm-ror51/root/usr/share/gems/gems/railties-5.1.4/lib/rails/initializable.rb:58

:in `run_initializers'

 | /opt/theforeman/tfm-ror51/root/usr/share/gems/gems/railties-5.1.4/lib/rails/application.rb:353:

in `initialize!'

 | /opt/theforeman/tfm-ror51/root/usr/share/gems/gems/railties-5.1.4/lib/rails/railtie.rb:185:in `

public_send'

 | /opt/theforeman/tfm-ror51/root/usr/share/gems/gems/railties-5.1.4/lib/rails/railtie.rb:185:in `

method_missing'

 | /usr/share/foreman/config/environment.rb:5:in `<top (required)>'

 | /opt/rh/rh-ruby24/root/usr/share/rubygems/rubygems/core_ext/kernel_require.rb:55:in `require'

 | /opt/rh/rh-ruby24/root/usr/share/rubygems/rubygems/core_ext/kernel_require.rb:55:in `require'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/polyglot-0.3.5/lib/polyglot.rb:65:in `require'

 | /opt/theforeman/tfm-ror51/root/usr/share/gems/gems/activesupport-5.1.4/lib/active_support/depen

dencies.rb:292:in `block in require'

 | /opt/theforeman/tfm-ror51/root/usr/share/gems/gems/activesupport-5.1.4/lib/active_support/depen

dencies.rb:258:in `load_dependency'

 | /opt/theforeman/tfm-ror51/root/usr/share/gems/gems/activesupport-5.1.4/lib/active_support/depen

dencies.rb:292:in `require'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/dynflow-1.0.0/lib/dynflow/rails/daemon.rb:46:in `r

un'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/dynflow-1.0.0/lib/dynflow/rails/daemon.rb:81:in `b

lock (2 levels) in run_background'
 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons/application.rb:265:in `b

lock in start_proc'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons/daemonize.rb:84:in `call

_as_daemon'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons/application.rb:269:in `s

tart_proc'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons/application.rb:295:in `s

tart'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons/monitor.rb:49:in `block 

(3 levels) in watch'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons/monitor.rb:49:in `fork'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons/monitor.rb:49:in `block 

(2 levels) in watch'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons/monitor.rb:43:in `each'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons/monitor.rb:43:in `block 

in watch'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons/monitor.rb:42:in `loop'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons/monitor.rb:42:in `watch'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons/monitor.rb:66:in `block 

in start_with_pidfile'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons/monitor.rb:61:in `fork'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons/monitor.rb:61:in `start_

with_pidfile'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons/monitor.rb:92:in `start'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons/application_group.rb:141

:in `create_monitor'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons/application.rb:283:in `s

tart'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons/controller.rb:56:in `run

'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons.rb:193:in `block in run_

proc'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons/cmdline.rb:88:in `catch_

exceptions'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/daemons-1.2.3/lib/daemons.rb:192:in `run_proc'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/dynflow-1.0.0/lib/dynflow/rails/daemon.rb:75:in `b

lock in run_background'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/dynflow-1.0.0/lib/dynflow/rails/daemon.rb:74:in `t

imes'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/dynflow-1.0.0/lib/dynflow/rails/daemon.rb:74:in `r

un_background'

 | /usr/sbin/dynflowd:71:in `block in <main>'

 | /usr/sbin/dynflowd:67:in `chdir'

 | /usr/sbin/dynflowd:67:in `<main>'

Related issues:

Blocks Foreman - Feature #3511:  As a security person, I would like Foreman t... Resolved

History

#1 - 04/18/2018 02:42 PM - Peter Ondrejka

- Subject changed from angular-rails-templates uses MD5 causing problems FIPS-enable envrionment added to angular-rails-templates uses MD5

causing problems FIPS-enabled envrionments

#2 - 04/18/2018 02:44 PM - Peter Ondrejka

- Blocks Feature #3511:  As a security person, I would like Foreman to run in FIPS mode added

#3 - 04/18/2018 05:51 PM - Justin Sherrill

- translation missing: en.field_release set to 114

#4 - 04/18/2018 06:17 PM - Anonymous

Created an upstream PR: https://github.com/pitr/angular-rails-templates/pull/158

#5 - 10/01/2018 01:51 PM - Ivan Necas

- Status changed from New to Ready For Testing
https://github.com/pitr/angular-rails-templates/pull/158


- Triaged set to No

- Pull request https://github.com/theforeman/foreman-packaging/pull/3046 added

Since the upstream is not responsive, proposing puling the change in during the rpm packaging in 

https://github.com/theforeman/foreman-packaging/pull/3046

#6 - 10/03/2018 05:44 PM - Jonathon Turel

- Project changed from Katello to Packaging

- Category set to RPMs

- Target version deleted (Katello Backlog)

- Triaged changed from No to Yes

- Fixed in Releases 1.20.0 added

#7 - 10/09/2018 05:21 PM - Anonymous

- Status changed from Ready For Testing to Closed
